<?php

require_once('/home/tezza/expressoDFD/prototype/rest/hypermedia/hypermedia.php');

use prototype\api\Config as Config;

class DynamicContactDeleteResource extends Resource{

    /**
    * Busca os eventos contidos nas agendas assinas do usurio
    *
    * @license    http://www.gnu.org/copyleft/gpl.html GPL
    * @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
    * @sponsor    Caixa Econmica Federal
    * @author     Adriano Coutinho da Silva
    * @author     Adir Kuhn
    * @return     Remove um resource do contato
    * @access     public
    **/
	function get($request) {
		try {

		    $response = new Response($request);
		    $response->addHeader('Content-type', 'aplication/json');
		    $this->secured();
		    $response->code = Response::OK;

		    $dynamicContact = Controller::find(array('concept' => 'dynamicContact'), false, array('filter' => array('=', 'owner', Config::me("uidNumber"))));
		    
		    $h = new Hypermedia();
		    $c = new Collection($request->resources, 'DynamicContactsResource');

		    foreach($dynamicContact as $value){
			$d = new Data();
			$i = new Item($request->resources, 'DynamicContactResource', $value['id']);
			
			$d->setName('name');
			$d->setValue($value['name']);
			$d->setPrompt('Nome do contato');
			$d->setDataType('string');
			$d->setMaxLength('100');
			$d->setMinLength(null);
			$d->setRequired(false);
			
			$i->addData($d);

			$d->setName('email');
			$d->setValue($value['mail']);
			$d->setPrompt('Email do contato');
			$d->setDataType('string');
			$d->setMaxLength('100');
			$d->setMinLength(null);
			$d->setRequired(true);
			
			$i->addData($d);			
			$l = new Link();

			$l->setHref($i->getHref());
			$l->setRel('delete');
			$l->setAlt('Remover');
			$l->setPrompt('Remover');
			$l->setRender('link');
			
			$i->addLink($l);
			
			$l->setHref($i->getHref());
			$l->setRel('put');
			$l->setAlt('Atualizar');
			$l->setPrompt('Atualizar');
			$l->setRender('link');
			
			$i->addLink($l);
			
			$l->setHref($i->getHref());
			$l->setRel('get');
			$l->setAlt('Buscar');
			$l->setPrompt('Buscar');
			$l->setRender('link');

			$i->addLink($l);
			$c->addItem($i);
		    }

		    $t = new Template();
		    $d = new Data();

		    $d->setName('name');
		    $d->setValue(null);
		    $d->setPrompt('Nome do contato');
		    $d->setDataType('string');
		    $d->setMaxLength(100);
		    $d->setMinLength(null);
		    $d->setRequired(false);

		    $t->addData($d);
		    $d = new Data();

		    $d->setName('email');
		    $d->setValue(null);
		    $d->setPrompt('Email do contato');
		    $d->setDataType('string');
		    $d->setMaxLength(100);
		    $d->setMinLength(null);
		    $d->setRequired(true);

		    $t->addData($d);

		    $c->setTemplate($t);
		    $d = new Data();

		    $d->setName('Dynamic Contacts');
		    $d->setValue(null);
		    $d->setPrompt('Contatos Dinmicos');
		    $d->setDataType(null);
		    $d->setMaxLength(null);
		    $d->setMinLength(null);
		    $d->setRequired(null);
		    
		    $c->setData($d);
		    
		    $h->setCollection($c);
		    
		}  catch (Exception $ex){
			$response->code = Response::INTERNALSERVERERROR;
			$error = array(
				'code' => '500',
				'title' => 'Internal Server Error',
				'description' => $ex);
			return $response;
		}

		$response->body = $h->getHypermeida($request->accept[10][0]);		
		return $response;
	}

}
?>
